<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<html>
<head>
   <meta name="keywords" content="Markov decision process, Toolbox, Scilab">
   <title> mdp_policy_iteration_modified description </title>
</head>
<body bgcolor="#FFFFFF">

<center><table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=2 WIDTH="100%" BGCOLOR="#FFFFCC" NOSAVE >
<tr BGCOLOR="#FFFFCC" NOSAVE>
<td BGCOLOR="#FFFFCC" NOSAVE><b>MDP Toolbox for Scilab</b></td>
<td><div align=right><a href="DOCUMENTATION.html"><img SRC="arrow.gif" height=23 width=26></a></div></td>
</tr>
</table></center>

<p><b><font color="#FF0000"><font size=+2>mdp_policy_iteration_modified</font></font></b>
<font color="#000000">
<p>Solves discounted MDP with modified policy iteration algorithm.
</font>


<p><b><font color="#3366FF"><font size=+1>Syntax</font></font></b>
<font color="#000000">
<p> [V, policy, iter, cpu_time] = mdp_value_iteration_modified (P, R, discount)
<br> [V, policy, iter, cpu_time] = mdp_value_iteration_modified (P, R, discount, epsilon)
<br> [V, policy, iter, cpu_time] = mdp_value_iteration_modified (P, R, discount, epsilon, max_iter)
</font>

<p><b><font color="#3366FF"><font size=+1>Description</font></font></b>
<font color="#000000">
<p>mdp_policy_iteration_modified applies the modified policy iteration
algorithm to solve discounted MDP. The algorithm
consists, like policy iteration one, in improving the policy iteratively
but in policy evaluation few iterations (max_iter) of value function updates done.
<br>Iterating is stopped when an epsilon-optimal policy is found.
<br>This function uses verbose and silent modes. In verbose mode, the function
displays the variation of V for each iteration.
</font>



<p><b><font color="#3366FF"><font size=+1>Arguments</font></font></b>
<font color="#000000">
<ul><li><b>P : </b>transition probability array.</li></ul>
P can be a 3 dimensions array (SxSxA) or a cell array (1xA), each cell containing a sparse matrix (SxS).
<ul><li><b>R : </b>reward array.</li></ul>
R can be a 3 dimensions array (SxSxA) or a cell array (1xA), each cell containing a sparse matrix (SxS) or a 2D array (SxA) possibly sparse.
<ul><li><b>discount : </b>discount factor.</li></ul>
discount is a real which belongs to ]0; 1].<br>
For discount equals to 1, a warning recalls to check conditions of convergence.
<ul><li><b>epsilon (optional) : </b>search for an epsilon-optimal policy.</li></ul>
epsilon is a real in ]0; 1].<br>
<br> By default, epsilon = 0.01.
<ul><li><b>max_iter (optional) : </b>maximum number of iterations to be done.</li></ul>
 max_iter is an integer greater than 0.
<br> By default, max_iter = 1000.<br>
</font>

<p><b><font color="#3366FF"><font size=+1>Evaluations</font></font></b>
<font color="#000000">
<ul><li><b>V :</b> optimal value fonction.</li></ul>
V is a (Sx1) vector.
<ul><li><b>policy : </b>optimal policy.</li></ul>
policy is a (Sx1) vector. Each element is an integer
corresponding to an action which maximizes the value function.
<ul><li><b>iter : </b>number of iterations.</li></ul>
<ul><li><b>cpu_time : </b>CPU time used to run the program.</li></ul>
</font>



<p><b><font color="#3366FF"><font size=+1>Example</font></font></b><br>
<font color="#999999">In grey, verbose mode display.</font><br>
<p><font color="#000000">
-> P(:,:,1) = [ 0.5 0.5; &nbsp 0.8 0.2 ];<br>
-> P(:,:,2) = [ 0   1; &nbsp 0.1 0.9 ];<br>
-> R = [ 5 10; &nbsp -1 2 ];<br>
<br>
-> [V, policy, iter, cpu_time] = mdp_policy_iteration_modified(P, R, 0.9)<br>
<font color="#999999">&nbsp &nbsp  Iteration  &nbsp V_variation<br>
&nbsp &nbsp &nbsp &nbsp &nbsp      1  &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp       8<br>
&nbsp &nbsp &nbsp &nbsp &nbsp      2  &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp       1.6239<br>
&nbsp &nbsp &nbsp &nbsp &nbsp      3  &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp       0.043773<br>
&nbsp &nbsp &nbsp &nbsp &nbsp      4  &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp       0.0011799<br>
&nbsp &nbsp &nbsp &nbsp &nbsp      5  &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp &nbsp       3.1807e-05<br></font>
V =<br>
&nbsp &nbsp   41.8656<br>
&nbsp &nbsp   35.4703<br>
policy =<br>
&nbsp &nbsp     2<br>
&nbsp &nbsp     1<br>
iter =<br>
&nbsp &nbsp     5<br>
cpu_time =<br>
&nbsp &nbsp    0.0500<br>
<br>
In the above example, P can be a cell array containing sparse matrices:<br>
-> P(1) = sparse([ 0.5 0.5;&nbsp   0.8 0.2 ]);<br>
-> P(2) = sparse([ 0 1;&nbsp   0.1 0.9 ]);<br>
The function call is unchanged.<br>
</font>
<br>


<table BORDER=0 CELLSPACING=0 CELLPADDING=0 COLS=2 WIDTH="100%" BGCOLOR="#FFFFCC" NOSAVE >
<tr NOSAVE>
<td NOSAVE><b>MDP Toolbox for Scilab</b></td>
<td><div align=right><a href="DOCUMENTATION.html"><img SRC="arrow.gif" height=23 width=26></a></div></td>
</tr>
</table>

<br>
<hr WIDTH="100%">
<font size=-1>MDPtoolbox/documentation/mdp_policy_iteration_modified.html
<br>Page created on July 31, 2001. Last update on August 31, 2009.</font>
</body>
</html>
